



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Eureka相关知识点</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Eureka相关知识点</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:23:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文讲述的是 Eureka server， 服务提供者、消费者的一些概念和配置说明。</p>
<h4>Eureka Server 服务注册中心</h4>
<h5>Eureka的高可用设计</h5>
<ul><li>Eureka侧重点是AP，高可用;Eureka Server在设计的时候就考虑了高可用，在Eureka的服务治理设计中，所有节点既是服务提供方，又是服务的消费方。<br /><br />
<em><strong>Eureka Server的高可用就是将自己的作为服务向其他服务注册中心注册自己，这样就形成一组互相注册的服务注册中心中心，以实现服务与服务之间的互相同步，达到高可用的效果（通俗一点就是：注册中心集群）</strong></em></li></ul>
<h5>失效剔除</h5>
<p>有时候，服务实例不一定会正常下线，而注册中心没有收到服务下线的请求，为了从列表中将这些无法提供服务的实例剔除，Eureka Server在启动的时候回创建一个定时任务，默认每隔一段时间（默认60s）将的当前服务中超时（默认90s）没续约得服务剔除出去。</p>
<h5>自我保护</h5>
<p>服务注册到Eureka Server后，会维护一个心跳连接，告诉Eureka Server 自己还活着。Eureka Server在运行期间会统计心跳失败的比例在15min以内是否低于85%；如果低于这种情况，Eureka Server会将当前注册的服务实例保护起来，让这些服务不会过期。这样做会使客户端容易拿到实际已经不存在的服务实例，会出现时而调用成功，时而失败的情况。<br /><br />
自我保护的相关属性配置</p>
<pre class="prettyprint linenums"><code>eureka.server.enableSelfPreservation=true # 可以设置改参数值为false，以确保注册中心将不可用的实例删除

</code></pre>
<h5>安全验证</h5>
<ol><li>添加spring security依赖</li></ol>
<pre class="prettyprint linenums"><code>&lt;dependency&gt;              &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;<br />
   &lt;artifactId&gt;spring-boot-starter-security&lt;/artifactId&gt;<br />
&lt;/dependency&gt;<br />
</code></pre>
<ol><li>在 serviceurl添加安全校验信息</li></ol>
<pre class="prettyprint linenums"><code>eureka.client.serviceUrl.defaultZone=http://&lt;username&gt;:&lt;password&gt;@${eureka.instance.hostname}:${server.port}/eureka/<br />
</code></pre>
<h4>服务提供者</h4>
<h5>服务注册</h5>
<p>服务提供者在服务启动的时候会以rest的方式将自己注册到Eureka Server上，同时带上自身服务的一些元数据信息。Eureka Server接收到这个rest请求后，将元数据存储到一个双层结构的Map中，其中，第一层的key是服务名，第二层的key是具体的服务实例名。<br /><br />
在服务注册时，需要确认一下<code>eureka.client.register-with-eureka=true</code> 是否正确，该配置默认是true，如果设置成<code>false</code>，则不会向注册中心注册该服务；</p>
<h5>服务同步</h5>
<p>从eureka服务治理体系架构图中可以看到，不同的服务提供者可以注册到不同非注册中心上，他们的信息呗不同的服务注册中心中心维护。<br /><br />
服务同步也就是不同的服务注册中心的数据相互同步。</p>
<h5>服务续约</h5>
<p>在服务注册之后，服务提供者会维护一个心跳来持续<code>通知</code>Eureka server。否则eureka server的剔除任务会将该服务实例从服务列表中排除出去。<br /><br />
下面是服务续约的两个重要属性</p>
<pre class="prettyprint linenums"><code>eureka.instance.lease-expiration-duration-in-seconds<br />
# leaseExpirationDurationInSeconds 表示Eureka server至少上一次收到client的心跳后，等待下一次心跳的超时时间，在这个时间如果没有收到下一次心跳，则将移除该服务实例。<br />
# 默认时间是90s，<br />
# 如果该值设置的过大，很可能会将请求转发过去的时候，该服务实例已经挂了<br />
# 如果该值设置的过小，则这个服务实例可能会因为临时的网络波动而被剔除。<br />
# 该值至少应该大于leaseRenewalIntervalInSeconds<br />
</code></pre>
<p><code>eureka.instance.lease-renewal-interval-in-seconds</code></p>
<blockquote><p><code>leaseRenewalIntervalInSeconds</code> 表示eureka client 发送心跳给server的频率（<em><strong>默认30s</strong></em>），如果在 <code>leaseExpirationDurationInSeconds</code> 后，server端没有收到client端的心跳，则将剔除这个服务实例，除此之外，如果这个示例实现了<code>HealthCheckCallback</code>，并决定由自让自己unavaliable，这个示例也将不会收到请求</p></blockquote>
<h4>服务消费者</h4>
<h5>获取服务</h5>
<p>消费者启动的时候，会发送rest请求从Eureka server 中获取到上面注册的服务列表。为了性能考虑，Eureka server会维护一份只读的服务注册清单返回给客户端，同时该缓存清单默认会每隔30s更新一次。<br /><br />
下面是获取服务的两个重要属性：</p>
<pre class="prettyprint linenums"><code>#是否需要去检索寻找服务，默认是true<br />
eureka.client.fetch-registry

# 表示Eureka client间隔多久去拉一次服务注册信息，默认是30s。<br />
eureka.client.registry-fetch-interval-seconds

</code></pre>
<h5>服务调用</h5>
<p>消费者在获取到服务清单后，通过服务名可以获取到具体的实例名和该实例的元数据信息，有了这些服务实例的详细信息，客户端可以根据自己的实际需要巨鼎调用哪个实例。Ribbon，feign实现服务调用的负载均衡。</p>
<h5>服务下线</h5>
<p>在系统的运行过程中，会出现关闭或重启某个示例的情况，在服务关闭操作时，会触发一个服务下线的rest请求给Eureka server，告诉server‘我要下线’。Eureka server 在接到该请求后，将服务状态下线。并同步到注册中心的其他节点</p>
<h4>配置详解</h4>
<p><img referrerpolicy="no-referrer"src="https://s2.ax1x.com/2019/02/15/kDzhxf.png"></p>
<h4>服务实例类配置</h4>
<h5>端点配置</h5>
<h5>元数据</h5>
<p>元数据是Eureka客户端向注册中心发送注册请求时，用来描述自身服务信息的对象，其中包含了一些标准化的元数据，比如服务名称、实例名称、实例ip、示例端口等用来服务治理的重要信息，以及一些用于负载均衡策略或是其他特殊用途的自定义元数据信息。<br /><br />
我们可以通过<code>eureka.instance.&lt;properties&gt;=&lt;value&gt;的格式来对标准化元数据进行配置</code>，其中 <code>properties</code>就是<code>EurekaInstanceConfigBean</code>对象中的成员变量。而对于自定义元数据，可以通过<code>eureka.instance.metadataMap.&lt;key&gt;=&lt;value&gt;</code>的格式来配置比如：<br /><br />
<code>eureka.instance.metadataMap.zone=tianjin </code></p>
<h5>健康检测</h5>
<p>默认情况下，Eureka中的各个服务实例的健康检测并不是通过<code>spring-boot-acturator</code>模块的/health端点来实现的，二十依靠客户端心跳的方式来保持服务实例的存活。在Eureka的服务续约与剔除机制下，客户端的健康状态从注册到注册中心开始都会处于up状态，除非心跳中指一段时间之后，服务注册中心将其剔除。默认的心跳实现方式可以有效检查客户端进程是否正常运作，但却无法保证客户端应用能够正常提供服务。<br /><br />
在spring cloud Eureka 中，可以把eureka客户端的健康检测交给<code>spring-boot-actuator</code>。可以实现更加全面的健康状态维护，设置方式如下</p>
<pre class="prettyprint linenums"><code>（1）在pom.xml中引入spring-boot-starter-actuator模块的依赖<br />
（2）在application.properties中增加参数配置eureka.client.healthcheck.enabled=true<br />
</code></pre>
<h4>通讯协议</h4>
<p>默认情况下，Eureka使用Jersey和XStream配合JSON作为Server与Client之间的通讯协议。也可以选择实现自己的协议来代替。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kjp469.html">Unity学习疑问记录之协程</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p7em49.html">springMVC中一个controller多个方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2oxko9.html">WebApi 消息拦截</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdzjnr8.html">json &bsol;u unicode字符串转化 c&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmjv109.html">彻底删除mysql服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydnryxq.html">group by是什么意思 mysql中</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1z0239.html">&lbrack;spring-framework&rsqb;Spring定时器的配置和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn7g7z8.html">bst 二叉搜索树简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjdkm38.html">Android&mdash;&mdash;内存调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxyrz8.html">Qt exe图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmd179.html">sinaBlog中小知识总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey0vwm9.html">VIJOS P1647 不差钱 SBT</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexdz78.html">输入url会发什什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg3xwr8.html">由html&comma;body&lbrace;height&colon;100&percnt;&rcub;引发的对html和body的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1jppjq.html">写个批处理脚本来帮忙干活--遍历文件夹&amp;amp&semi;字符串处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljz73e9.html">box-sizing&colon;border-boxing的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gmnr0q.html">while循环、格式化输出、运算符和编码初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdzd5d9.html">python的相对导入</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o0vng8.html">【慕课网实战】一、以慕课网日志分析为例 进入大数据 Spark SQL 的世界</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdzgez9.html">解决eclipse运行内存溢出方案</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rgvve48.html">js-day04--Ajax应用--二级联动</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpxy4r9.html">&lbrack;转&rsqb;jenkins2 插件安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zodgr3q.html">&lbrack;Swift&rsqb;LeetCode309&period; 最佳买卖股票时机含冷冻期 &vert; Best Time to Buy and Sell Stock with Cooldown</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z6zxx9.html">优化之Aggregator组件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkpdez8.html">Python内置函数&lpar;33&rpar;&mdash;&mdash;int</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd0wxy9.html">Python内置函数&lpar;61&rpar;&mdash;&mdash;str</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zody5dq.html">汇编语言 实验14 访问CMOS RAM</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k0vk49.html">JVM虚拟机（1）---常用JVM配置参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwmeg8.html">redhat 6&period;5安装ansible</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me3dp6q.html">Python爬虫入门教程 19-100 51CTO学院IT技术课程抓取</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
